package com.jdbernard.teammaker

public class Game {
    static int BASE_POINT_VALUE = 1

    // lists of players for each team
    List team1
    List team2

    // stats for each game
    Map threePointAttempts = [:]
    Map threePointers = [:]
    Map twoPointAttempts = [:]
    Map twoPointers = [:]
    Map rebounds = [:]
    Map assists = [:]
    Map turnovers = [:]

    public int getTeam1Score() { return getTeamScore(team1) }
    public int getTeam2Score() { return getTeamScore(team2) }

    public int getTeamScore(List team) { return team.sum { getPlayerScore(it) } }

    public int getPlayerScore(Player player) {
        return (twoPointers[(player.name)] ?: 0) * BASE_POINT_VALUE +
            (threePointers[(player.name)] ?: 0) * (BASE_POINT_VALUE + 1)
    }

    public int getTeamRebounds(List team) {
        return team.sum { rebounds[(it.name)] ?: 0 }
    }

    public int getTeamTurnovers(List team) {
        return team.sum { turnovers[(it.name)] ?: 0 }
    }
}
