package com.jdbernard.teammaker

public class Player implements Comparable<Player> {
    // persistant data
    String name
    List games

    // transient data
    int gamesSat
    boolean benched

    public int getPlusMinus() {
        if (games.size() == 0) return 0
        int plusMinus games.sum { game ->
            if (game.team1.contains(this)) {
                return game.team1Score - game.team2Score
            else return game.team2Score - game.team1Score
        }
        return plusMinus / games.size()
    }

    public float getPointsPerGame() {
        float points = 0
        games.each { game ->
            points += (game.threePointers[(name)] ?: 0) * (Game.BASE_POINT_VALUE + 1)
            points += (game.twoPointers[(name)] ?: 0) * (Game.BASE_POINT_VALUE)
        }

        return (games.size() == 0 ? 0 : points /= games.size())
    }

    public float getReboundsPerGame() {
        if (games.size() == 0) return 0
        return games.sum { it.rebounds[(name)] ?: 0 } / games.size()
    }

    public float getAssistsPerGame() {
        if (games.size() == 0) return 0
        return games.sum { it.assists[(name)] ?: 0 } / games.size()
    }

    public float getTurnoversPerGame() {
        if (games.size() == 0) return 0
        else return games.sum { it.turnovers[(name)] ?: 0 } / games.size()
    }

    public int compareTo(Player that) {
        int r = that.gamesSat - this.gamesSat
        if (r == 0) r = this.name.compareTo(that.name)
        return r
    }

    public String toString() { return name }
}
